<?php

/**
 * This code was generated by
 * \ / _    _  _|   _  _
 * | (_)\/(_)(_|\/| |(/_  v1.0.0
 * /       /
 */

namespace Twilio\Rest\Preview\Permissions\VoicePermission;

use Twilio\Options;
use Twilio\Values;

/**
 * PLEASE NOTE that this class contains preview products that are subject to change. Use them with caution. If you currently do not have developer preview access, please contact help@twilio.com.
 */
abstract class SettingsOptions {
    /**
     * @param boolean $inheritance Set true to enable inheritance voice permissions
     *                             settings, false to disable
     * @return UpdateSettingsOptions Options builder
     */
    public static function update($inheritance = Values::NONE) {
        return new UpdateSettingsOptions($inheritance);
    }
}

class UpdateSettingsOptions extends Options {
    /**
     * @param boolean $inheritance Set true to enable inheritance voice permissions
     *                             settings, false to disable
     */
    public function __construct($inheritance = Values::NONE) {
        $this->options['inheritance'] = $inheritance;
    }

    /**
     * Set true to enable inheritance of outbound voice permissions and blocklist, false to disable
     * 
     * @param boolean $inheritance Set true to enable inheritance voice permissions
     *                             settings, false to disable
     * @return $this Fluent Builder
     */
    public function setInheritance($inheritance) {
        $this->options['inheritance'] = $inheritance;
        return $this;
    }

    /**
     * Provide a friendly representation
     * 
     * @return string Machine friendly representation
     */
    public function __toString() {
        $options = array();
        foreach ($this->options as $key => $value) {
            if ($value != Values::NONE) {
                $options[] = "$key=$value";
            }
        }
        return '[Twilio.Preview.Permissions.UpdateSettingsOptions ' . implode(' ', $options) . ']';
    }
}